## mingw-w64-nng-1.11-1.src.tar.zst

=== src/core/CMakeLists.txt ===
#
# Copyright 2024 Staysail Systems, Inc. <info@staystail.tech>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#

#  Core.
nng_directory(core)

nng_check_sym(strlcpy string.h NNG_HAVE_STRLCPY)
nng_check_sym(strnlen string.h NNG_HAVE_STRNLEN)
nng_check_sym(strcasecmp string.h NNG_HAVE_STRCASECMP)
nng_check_sym(strncasecmp string.h NNG_HAVE_STRNCASECMP)
nng_check_sym(localtime_r time.h NNG_HAVE_LOCALTIME_R)

nng_sources(
        defs.h

        aio.c
        aio.h
        device.c
        device.h
        dialer.c
        dialer.h
        sockfd.c
        sockfd.h
        file.c
        file.h
        idhash.c
        idhash.h
        init.c
        init.h
        list.c
        list.h
        listener.c
        listener.h
        lmq.c
        lmq.h
        log.c
        message.c
        message.h
        msgqueue.c
        msgqueue.h
        nng_impl.h
        options.c
        options.h
        pollable.c
        pollable.h
        panic.c
        panic.h
        pipe.c
        pipe.h
        platform.h
        protocol.h
        reap.c
        reap.h
        sockaddr.c
        socket.c
        socket.h
        sockimpl.h
        stats.c
        stats.h
        stream.c
        stream.h
        strs.c
        strs.h
        taskq.c
        taskq.h
        tcp.c
        tcp.h
        thread.c
        thread.h
        url.c
        url.h
)

nng_test(aio_test)
nng_test(buf_size_test)
nng_test(errors_test)
nng_test(id_test)
nng_test(init_test)
nng_test(list_test)
nng_test(log_test)
nng_test(message_test)
nng_test(reconnect_test)
nng_test(sock_test)
nng_test(sockaddr_test)
nng_test(stats_test)
nng_test(url_test)

=== src/sp/protocol/CMakeLists.txt ===
#
# Copyright 2020 Staysail Systems, Inc. <info@staystail.tech>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#

#  Protocols.
nng_directory(protocol)

add_subdirectory(bus0)
add_subdirectory(pair0)
add_subdirectory(pair1)
add_subdirectory(pipeline0)
add_subdirectory(pubsub0)
add_subdirectory(reqrep0)
add_subdirectory(survey0)

=== src/sp/transport/CMakeLists.txt ===
#
# Copyright 2023 Staysail Systems, Inc. <info@staystail.tech>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#

#  Transports.
nng_directory(transport)

add_subdirectory(socket)
add_subdirectory(inproc)
add_subdirectory(ipc)
add_subdirectory(tcp)
add_subdirectory(tls)
add_subdirectory(ws)
add_subdirectory(zerotier)

=== PKGBUILD ===
# Contributor: Kreijstal <rainb@tfwno.gf>

_realname=nng
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.11
pkgrel=1
pkgdesc="A lightweight, broker-less library (mingw-w64)"
arch=('any')
mingw_arch=( 'ucrt64' 'clang64' 'clangarm64')
url='https://nng.nanomsg.org/'
msys2_repository_url='https://github.com/nanomsg/nng'
license=('spdx:MIT')
depends=("${MINGW_PACKAGE_PREFIX}-wolfssl")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/nanomsg/nng/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('12aaff6f8f183ba0fec378af8620c47cf4be6da975d016ec6cdec2fbac0d3534')

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-CMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DNNG_ENABLE_TLS=ON \
      -DNNG_TLS_ENGINE=wolf \
      -DNNG_ENABLE_DOC=OFF \
      -DNNG_TESTS=OFF \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
